unit schUnidadesMedidaServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schUnidadesMedidaClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_UnidadesMedidaDelta = '{5CD2E828-7EE8-4427-A2EA-4580837BD172}';

type
  { IUnidadesMedidaDelta }
  IUnidadesMedidaDelta = interface(IUnidadesMedida)
  ['{5CD2E828-7EE8-4427-A2EA-4580837BD172}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldDESCRIPCIONValue : String;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
  end;

  { TUnidadesMedidaBusinessProcessorRules }
  TUnidadesMedidaBusinessProcessorRules = class(TDABusinessProcessorRules, IUnidadesMedida, IUnidadesMedidaDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull : Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldDESCRIPCIONIsNull : Boolean read GetOldDESCRIPCIONIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TUnidadesMedidaBusinessProcessorRules }
constructor TUnidadesMedidaBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TUnidadesMedidaBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TUnidadesMedidaBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaID];
end;

function TUnidadesMedidaBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaID]);
end;

function TUnidadesMedidaBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_UnidadesMedidaID];
end;

function TUnidadesMedidaBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_UnidadesMedidaID]);
end;

procedure TUnidadesMedidaBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaID] := aValue;
end;

procedure TUnidadesMedidaBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaID] := Null;
end;

function TUnidadesMedidaBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaDESCRIPCION];
end;

function TUnidadesMedidaBusinessProcessorRules.GetDESCRIPCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaDESCRIPCION]);
end;

function TUnidadesMedidaBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_UnidadesMedidaDESCRIPCION];
end;

function TUnidadesMedidaBusinessProcessorRules.GetOldDESCRIPCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_UnidadesMedidaDESCRIPCION]);
end;

procedure TUnidadesMedidaBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaDESCRIPCION] := aValue;
end;

procedure TUnidadesMedidaBusinessProcessorRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_UnidadesMedidaDESCRIPCION] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_UnidadesMedidaDelta, TUnidadesMedidaBusinessProcessorRules);

end.
